/*
 * ** PIR Private Directory Service prototype
 * ** Copyright (C) 2003 Alexander Iliev <iliev@nimbus.dartmouth.edu>
 * **
 * ** This program is free software; you can redistribute it and/or modify
 * ** it under the terms of the GNU General Public License as published by
 * ** the Free Software Foundation; either version 2 of the License, or
 * ** (at your option) any later version.
 * **
 * ** This program is distributed in the hope that it will be useful,
 * ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 * ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * ** GNU General Public License for more details.
 * **
 * ** You should have received a copy of the GNU General Public License
 * ** along with this program; if not, write to the Free Software
 * ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * */

/*
 * alex iliev, feb 2003
 * bit_matrix.cc
 */

#include <vector>

#include "bit_matrix.h"


using namespace std;


//
// slice-matrix indexing functions
//
bit_vector::reference idx (bit_matrix & m,
			   const matrix_slice_info_t& s,
			   size_t col, size_t row)
{
    return m[s.start_col + col][s.start_row + row];
}

bit_vector::const_reference idx (const bit_matrix & m,
				 const matrix_slice_info_t& s,
				 size_t col, size_t row)
{
    return m[s.start_col + col][s.start_row + row];
}


//
// slice-matrix column-extraction
//
bit_matrix::reference column (bit_matrix & m,
			      const matrix_slice_info_t& s,
			      size_t col)
{
    return m[s.start_col + col];
}


bit_matrix::const_reference column (const bit_matrix & m,
				    const matrix_slice_info_t& s,
				    size_t col)
{
    return m[s.start_col + col];
}




//
// slice-vector indexing
//
bit_vector::reference idx (bit_vector & v,
			   const matrix_slice_info_t& s,
			   size_t row)
{
    return v[s.start_row + row];
}

bit_vector::const_reference idx (const bit_vector & v,
				 const matrix_slice_info_t& s,
				 size_t row)
{
    return v[s.start_row + row];
}
