#!/usr/bin/perl -w

# extract the query times from a dump produced by query-driver.hs


my (@start_times, @end_times);

sub parseTime {
  $_ = shift;
  my ($y, $m, $d, $h, $min, $s) = split /-/;
  # get the number of seconds, using only the hour and smaller units
  return (((($h*60) + $min)*60) + $s);
}


while (<>) {
  my ($num, $time);

  ($num, $time) = /<time-start num="(.*)">(.*)<\/time-start>/;
  if (defined $num and defined $time) {
    $start_times[$num-1] = parseTime $time;
#    print "start $num $start_times[$num]\n";
    next;
  }

  ($num, $time) = /<time-done num="(.*)">(.*)<\/time-done>/;
  if (defined $num and defined $time) {
    $end_times[$num-1] = parseTime $time;
#    print "done $num $end_times[$num]\n";
    next;
  }

}

my $begin = $start_times[0];

for (my $i=0; $i <= $#start_times; $i++) {
  print $start_times[$i] - $begin, " ", $end_times[$i] - $start_times[$i], "\n";
}

