#!/bin/bash

# pir-query.sh
# alex iliev, jan 2003
# 
# OpenLDAP shell backend script which talks to the PIR search program
#


CODEBASE=~/work/shib/code
PIRDIR=$CODEBASE/host


while read TAG VALUE; do
    case "$TAG" in
	base:)
	    BASE=$VALUE
	    ;;
	filter:)
	    FILTER=$VALUE
	    ;;
	attrs:)
	    ATTRS=$VALUE	# what attributes to return

	    # include other parameters here
    esac
done


# fairly primitive filter parsing!
name=`echo $FILTER | sed -e 's/.*=\(.*\))/\1/'`

errfile=`mktemp -t pirsearch-errs.XXXXXXXX`


echo $name | $PIRDIR/pirsearch 2 2>$errfile | {
    read recname

    echo dn: cn=$recname,$BASE
    echo objectclass: top
    echo objectclass: person
    echo cn: $recname

    # read and print the attributes
    while read name && read value; do
	echo $name: $value
    done
}

echo
echo RESULT
echo code: 0


(
    [ -s $errfile ] && {
	echo While looking for $name at `date`:
	cat $errfile
	echo
    } >> $PIRDIR/search-errors
    rm -f $errfile
) &
